Index: /palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3866)
@@ -663,17 +668,17 @@
 !>     coordinate xy.
 !------------------------------------------------------------------------------!
-    ELEMENTAL REAL(dp) FUNCTION project(xy, xy0, r)
-       REAL(dp), INTENT(IN)  ::  xy, xy0, r
-       REAL(dp) :: ri
-
-!
-!--    If this elemental function is called with a large array as xy, it is
-!--    computationally more efficient to precompute the inverse radius and
-!--    then muliply.
-       ri = 1.0_dp / r
-
-       project = (xy - xy0) * ri
-
-    END FUNCTION project
+ ELEMENTAL REAL(wp) FUNCTION project(xy, xy0, r)
+    REAL(wp), INTENT(IN)  ::  xy, xy0, r
+    REAL(wp) :: ri
+
+!
+!-- If this elemental function is called with a large array as xy, it is
+!-- computationally more efficient to precompute the inverse radius and
+!-- then muliply.
+    ri = 1.0_wp / r
+
+    project = (xy - xy0) * ri
+
+ END FUNCTION project
 
 
@@ -684,10 +689,10 @@
 !> compute the geographical latitude of its rotated north pole.
 !------------------------------------------------------------------------------!
-    REAL(dp) FUNCTION phic_to_phin(phi_c)
-        REAL(dp), INTENT(IN) ::  phi_c
-
-        phic_to_phin = 0.5_dp * PI - ABS(phi_c)
-
-    END FUNCTION phic_to_phin
+ REAL(wp) FUNCTION phic_to_phin(phi_c)
+     REAL(wp), INTENT(IN) ::  phi_c
+
+     phic_to_phin = 0.5_wp * PI - ABS(phi_c)
+
+ END FUNCTION phic_to_phin
 
     
@@ -699,13 +704,13 @@
 !> north pole.
 !------------------------------------------------------------------------------!
-    REAL(dp) FUNCTION lamc_to_lamn(phi_c, lam_c)
-       REAL(dp), INTENT(IN) ::  phi_c, lam_c
-        
-       lamc_to_lamn = lam_c
-       IF (phi_c > 0.0_dp)  THEN
-          lamc_to_lamn = lam_c - SIGN(PI, lam_c)
-       ENDIF
-
-    END FUNCTION lamc_to_lamn
+ REAL(wp) FUNCTION lamc_to_lamn(phi_c, lam_c)
+    REAL(wp), INTENT(IN) ::  phi_c, lam_c
+     
+    lamc_to_lamn = lam_c
+    IF (phi_c > 0.0_wp)  THEN
+       lamc_to_lamn = lam_c - SIGN(PI, lam_c)
+    ENDIF
+
+ END FUNCTION lamc_to_lamn
 
 
@@ -718,18 +723,18 @@
 !> rotated-pole coordinate transformations.
 !------------------------------------------------------------------------------!
-    REAL(dp) FUNCTION gamma_from_hemisphere(phi_cg, phi_ref)
-       REAL(dp), INTENT(IN) ::  phi_cg
-       REAL(dp), INTENT(IN) ::  phi_ref
-
-       LOGICAL ::  palm_origin_is_south_of_cosmo_origin
-       
-       palm_origin_is_south_of_cosmo_origin = (phi_cg < phi_ref)
-
-       IF (palm_origin_is_south_of_cosmo_origin)  THEN
-           gamma_from_hemisphere = PI
-       ELSE
-           gamma_from_hemisphere = 0.0_dp
-       ENDIF
-    END FUNCTION gamma_from_hemisphere
+ REAL(wp) FUNCTION gamma_from_hemisphere(phi_cg, phi_ref)
+    REAL(wp), INTENT(IN) ::  phi_cg
+    REAL(wp), INTENT(IN) ::  phi_ref
+
+    LOGICAL ::  palm_origin_is_south_of_cosmo_origin
+    
+    palm_origin_is_south_of_cosmo_origin = (phi_cg < phi_ref)
+
+    IF (palm_origin_is_south_of_cosmo_origin)  THEN
+        gamma_from_hemisphere = PI
+    ELSE
+        gamma_from_hemisphere = 0.0_wp
+    ENDIF
+ END FUNCTION gamma_from_hemisphere
 
 
@@ -760,45 +765,45 @@
 !> phi(:,:), lam(:,:): geographical latitudes and logitudes
 !------------------------------------------------------------------------------!
-    SUBROUTINE rotate_to_cosmo(phir, lamr, phip, lamp, phi, lam, gam)
-       REAL(dp), INTENT(IN)  ::  phir(0:), lamr(0:), phip, lamp, gam
-       REAL(dp), INTENT(OUT) ::  phi(0:,0:), lam(0:,0:)
-
-       INTEGER ::  i, j
+ SUBROUTINE rotate_to_cosmo(phir, lamr, phip, lamp, phi, lam, gam)
+    REAL(wp), INTENT(IN)  ::  phir(0:), lamr(0:), phip, lamp, gam
+    REAL(wp), INTENT(OUT) ::  phi(0:,0:), lam(0:,0:)
+
+    INTEGER ::  i, j
+    
+    IF ( SIZE(phi, 1) .NE. SIZE(lam, 1) .OR. &
+         SIZE(phi, 2) .NE. SIZE(lam, 2) )  THEN
+       PRINT *, "inifor: rotate_to_cosmo: Dimensions of phi and lambda do not match. Dimensions are:"
+       PRINT *, "inifor: rotate_to_cosmo: phi: ", SIZE(phi, 1), SIZE(phi, 2)
+       PRINT *, "inifor: rotate_to_cosmo: lam: ", SIZE(lam, 1), SIZE(lam, 2)
+       STOP
+    ENDIF
+
+    IF ( SIZE(phir) .NE. SIZE(phi, 2) .OR. &
+         SIZE(lamr) .NE. SIZE(phi, 1) )  THEN
+       PRINT *, "inifor: rotate_to_cosmo: Dimensions of phir and lamr do not match. Dimensions are:"
+       PRINT *, "inifor: rotate_to_cosmo: phir: ", SIZE(phir), SIZE(phi, 2)
+       PRINT *, "inifor: rotate_to_cosmo: lamr: ", SIZE(lamr), SIZE(phi, 1)
+       STOP
+    ENDIF
+    
+    DO  j = 0, UBOUND(phir, 1)
+       DO  i = 0, UBOUND(lamr, 1)
+
+          phi(i,j) = phirot2phi(phir(j) * TO_DEGREES,                       &
+                                lamr(i) * TO_DEGREES,                       &
+                                phip * TO_DEGREES,                          &
+                                gam  * TO_DEGREES) * TO_RADIANS
+
+          lam(i,j) = rlarot2rla(phir(j) * TO_DEGREES,                       &
+                                lamr(i) * TO_DEGREES,                       &
+                                phip * TO_DEGREES,                          &
+                                lamp * TO_DEGREES,                          &
+                                gam  * TO_DEGREES) * TO_RADIANS
+
+       ENDDO
+    ENDDO
+
+ END SUBROUTINE rotate_to_cosmo
        
-       IF ( SIZE(phi, 1) .NE. SIZE(lam, 1) .OR. &
-            SIZE(phi, 2) .NE. SIZE(lam, 2) )  THEN
-          PRINT *, "inifor: rotate_to_cosmo: Dimensions of phi and lambda do not match. Dimensions are:"
-          PRINT *, "inifor: rotate_to_cosmo: phi: ", SIZE(phi, 1), SIZE(phi, 2)
-          PRINT *, "inifor: rotate_to_cosmo: lam: ", SIZE(lam, 1), SIZE(lam, 2)
-          STOP
-       ENDIF
-
-       IF ( SIZE(phir) .NE. SIZE(phi, 2) .OR. &
-            SIZE(lamr) .NE. SIZE(phi, 1) )  THEN
-          PRINT *, "inifor: rotate_to_cosmo: Dimensions of phir and lamr do not match. Dimensions are:"
-          PRINT *, "inifor: rotate_to_cosmo: phir: ", SIZE(phir), SIZE(phi, 2)
-          PRINT *, "inifor: rotate_to_cosmo: lamr: ", SIZE(lamr), SIZE(phi, 1)
-          STOP
-       ENDIF
-       
-       DO j = 0, UBOUND(phir, 1)
-          DO i = 0, UBOUND(lamr, 1)
-
-             phi(i,j) = phirot2phi(phir(j) * TO_DEGREES,                       &
-                                   lamr(i) * TO_DEGREES,                       &
-                                   phip * TO_DEGREES,                          &
-                                   gam  * TO_DEGREES) * TO_RADIANS
-
-             lam(i,j) = rlarot2rla(phir(j) * TO_DEGREES,                       &
-                                   lamr(i) * TO_DEGREES,                       &
-                                   phip * TO_DEGREES,                          &
-                                   lamp * TO_DEGREES,                          &
-                                   gam  * TO_DEGREES) * TO_RADIANS
-
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE rotate_to_cosmo
-       
 
 !------------------------------------------------------------------------------!
@@ -807,30 +812,30 @@
 !> Rotate the given vector field (x(:), y(:)) by the given 'angle'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE rotate_vector_field(x, y, angle)
-       REAL(dp), DIMENSION(:), INTENT(INOUT) :: x, y  !< x and y coodrinate in arbitrary units
-       REAL(dp), INTENT(IN)                  :: angle !< rotation angle [deg]
-
-       INTEGER  :: i
-       REAL(dp) :: sine, cosine, v_rot(2), rotation(2,2)
-
-       sine = SIN(angle * TO_RADIANS)
-       cosine = COS(angle * TO_RADIANS)
-!
-!--    RESAHPE() fills columns first, so the rotation matrix becomes
-!--    
-!--    rotation = [ cosine   -sine  ]
-!--               [  sine    cosine ]
-       rotation = RESHAPE( (/cosine, sine, -sine, cosine/), (/2, 2/) )
-
-       DO i = LBOUND(x, 1), UBOUND(x, 1)
-
-          v_rot(:) = MATMUL(rotation, (/x(i), y(i)/))
-
-          x(i) = v_rot(1)
-          y(i) = v_rot(2)
-
-       ENDDO
-
-    END SUBROUTINE rotate_vector_field
+ SUBROUTINE rotate_vector_field(x, y, angle)
+    REAL(wp), DIMENSION(:), INTENT(INOUT) :: x, y  !< x and y coodrinate in arbitrary units
+    REAL(wp), INTENT(IN)                  :: angle !< rotation angle [deg]
+
+    INTEGER  :: i
+    REAL(wp) :: sine, cosine, v_rot(2), rotation(2,2)
+
+    sine = SIN(angle * TO_RADIANS)
+    cosine = COS(angle * TO_RADIANS)
+!
+!-- RESAHPE() fills columns first, so the rotation matrix becomes
+!-- 
+!-- rotation = [ cosine   -sine  ]
+!--            [  sine    cosine ]
+    rotation = RESHAPE( (/cosine, sine, -sine, cosine/), (/2, 2/) )
+
+    DO  i = LBOUND(x, 1), UBOUND(x, 1)
+
+       v_rot(:) = MATMUL(rotation, (/x(i), y(i)/))
+
+       x(i) = v_rot(1)
+       y(i) = v_rot(2)
+
+    ENDDO
+
+ END SUBROUTINE rotate_vector_field
 
 
@@ -847,15 +852,15 @@
 !>    https://www.dwd.de/SharedDocs/downloads/DE/modelldokumentationen/nwv/cosmo_d2/cosmo_d2_dbbeschr_aktuell.pdf?__blob=publicationFile&v=2
 !------------------------------------------------------------------------------!
-    FUNCTION meridian_convergence_rotated(phi_n, lam_n, phi_g, lam_g)          &
-       RESULT(delta)
-
-       REAL(dp), INTENT(IN) ::  phi_n, lam_n, phi_g, lam_g
-       REAL(dp)             ::  delta
-
-       delta = atan2( COS(phi_n) * SIN(lam_n - lam_g),                         &
-                      COS(phi_g) * SIN(phi_n) -                                &
-                      SIN(phi_g) * COS(phi_n) * COS(lam_n - lam_g) )
-
-    END FUNCTION meridian_convergence_rotated
+ FUNCTION meridian_convergence_rotated(phi_n, lam_n, phi_g, lam_g)          &
+    RESULT(delta)
+
+    REAL(wp), INTENT(IN) ::  phi_n, lam_n, phi_g, lam_g
+    REAL(wp)             ::  delta
+
+    delta = atan2( COS(phi_n) * SIN(lam_n - lam_g),                         &
+                   COS(phi_g) * SIN(phi_n) -                                &
+                   SIN(phi_g) * COS(phi_n) * COS(lam_n - lam_g) )
+
+ END FUNCTION meridian_convergence_rotated
 
 !------------------------------------------------------------------------------!
@@ -903,56 +908,56 @@
 !> 
 !------------------------------------------------------------------------------!
-    SUBROUTINE find_horizontal_neighbours(cosmo_lat, cosmo_lon,                &
-                                          palm_clat, palm_clon,                &
-                                          palm_ii, palm_jj)
-
-       REAL(dp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
-       REAL(dp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
-       REAL(dp)                                   ::  cosmo_dxi, cosmo_dyi
-       INTEGER, DIMENSION(0:,0:,1:), INTENT(OUT)  ::  palm_ii, palm_jj
-
-       REAL(dp) ::  lonpos, latpos, lon0, lat0
-       INTEGER  ::  i, j
-
-       lon0 = cosmo_lon(0)
-       lat0 = cosmo_lat(0)
-       cosmo_dxi = 1.0_dp / (cosmo_lon(1) - cosmo_lon(0))
-       cosmo_dyi = 1.0_dp / (cosmo_lat(1) - cosmo_lat(0))
-
-       DO j = 0, UBOUND(palm_clon, 2)!palm_grid % ny
-       DO i = 0, UBOUND(palm_clon, 1)!palm_grid % nx
-!
-!--       Compute the floating point index corrseponding to PALM-4U grid point
-!--       location along target grid (COSMO-DE) axes.
-          lonpos = (palm_clon(i,j) - lon0) * cosmo_dxi
-          latpos = (palm_clat(i,j) - lat0) * cosmo_dyi
-
-          IF (lonpos < 0.0_dp .OR. latpos < 0.0_dp)  THEN
-             message = "lonpos or latpos out of bounds " //                    &
-                "while finding interpolation neighbours!" // NEW_LINE(' ') //  &
-                "          (i,j) = (" //                                       &
-                TRIM(str(i)) // ", " // TRIM(str(j)) // ")" // NEW_LINE(' ') //&
-                "          lonpos " // TRIM(real_to_str(lonpos*TO_DEGREES)) // &
-                ", latpos " // TRIM(real_to_str(latpos*TO_DEGREES)) // NEW_LINE(' ') // &
-                "          lon0 " // TRIM(real_to_str(lon0  *TO_DEGREES)) //   &
-                ", lat0   " // TRIM(real_to_str(lat0*TO_DEGREES)) // NEW_LINE(' ') // &
-                "          PALM lon " // TRIM(real_to_str(palm_clon(i,j)*TO_DEGREES)) // &
-                ", PALM lat " // TRIM(real_to_str(palm_clat(i,j)*TO_DEGREES))
-             CALL inifor_abort('find_horizontal_neighbours', message)
-          ENDIF
-
-          palm_ii(i,j,1) = FLOOR(lonpos)
-          palm_ii(i,j,2) = FLOOR(lonpos)
-          palm_ii(i,j,3) = CEILING(lonpos)
-          palm_ii(i,j,4) = CEILING(lonpos)
-
-          palm_jj(i,j,1) = FLOOR(latpos)
-          palm_jj(i,j,2) = CEILING(latpos)
-          palm_jj(i,j,3) = CEILING(latpos)
-          palm_jj(i,j,4) = FLOOR(latpos)
-       ENDDO
-       ENDDO
-
-    END SUBROUTINE find_horizontal_neighbours
+ SUBROUTINE find_horizontal_neighbours(cosmo_lat, cosmo_lon,                &
+                                       palm_clat, palm_clon,                &
+                                       palm_ii, palm_jj)
+
+    REAL(wp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
+    REAL(wp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
+    REAL(wp)                                   ::  cosmo_dxi, cosmo_dyi
+    INTEGER, DIMENSION(0:,0:,1:), INTENT(OUT)  ::  palm_ii, palm_jj
+
+    REAL(wp) ::  lonpos, latpos, lon0, lat0
+    INTEGER  ::  i, j
+
+    lon0 = cosmo_lon(0)
+    lat0 = cosmo_lat(0)
+    cosmo_dxi = 1.0_wp / (cosmo_lon(1) - cosmo_lon(0))
+    cosmo_dyi = 1.0_wp / (cosmo_lat(1) - cosmo_lat(0))
+
+    DO  j = 0, UBOUND(palm_clon, 2)!palm_grid%ny
+    DO  i = 0, UBOUND(palm_clon, 1)!palm_grid%nx
+!
+!--    Compute the floating point index corrseponding to PALM-4U grid point
+!--    location along target grid (COSMO-DE) axes.
+       lonpos = (palm_clon(i,j) - lon0) * cosmo_dxi
+       latpos = (palm_clat(i,j) - lat0) * cosmo_dyi
+
+       IF (lonpos < 0.0_wp .OR. latpos < 0.0_wp)  THEN
+          message = "lonpos or latpos out of bounds " //                    &
+             "while finding interpolation neighbours!" // NEW_LINE(' ') //  &
+             "          (i,j) = (" //                                       &
+             TRIM(str(i)) // ", " // TRIM(str(j)) // ")" // NEW_LINE(' ') //&
+             "          lonpos " // TRIM(real_to_str(lonpos*TO_DEGREES)) // &
+             ", latpos " // TRIM(real_to_str(latpos*TO_DEGREES)) // NEW_LINE(' ') // &
+             "          lon0 " // TRIM(real_to_str(lon0  *TO_DEGREES)) //   &
+             ", lat0   " // TRIM(real_to_str(lat0*TO_DEGREES)) // NEW_LINE(' ') // &
+             "          PALM lon " // TRIM(real_to_str(palm_clon(i,j)*TO_DEGREES)) // &
+             ", PALM lat " // TRIM(real_to_str(palm_clat(i,j)*TO_DEGREES))
+          CALL inifor_abort('find_horizontal_neighbours', message)
+       ENDIF
+
+       palm_ii(i,j,1) = FLOOR(lonpos)
+       palm_ii(i,j,2) = FLOOR(lonpos)
+       palm_ii(i,j,3) = CEILING(lonpos)
+       palm_ii(i,j,4) = CEILING(lonpos)
+
+       palm_jj(i,j,1) = FLOOR(latpos)
+       palm_jj(i,j,2) = CEILING(latpos)
+       palm_jj(i,j,3) = CEILING(latpos)
+       palm_jj(i,j,4) = FLOOR(latpos)
+    ENDDO
+    ENDDO
+
+ END SUBROUTINE find_horizontal_neighbours
 
     
@@ -963,106 +968,106 @@
 !> column of the given palm grid.
 !------------------------------------------------------------------------------!
-    SUBROUTINE find_vertical_neighbours_and_weights_interp( palm_grid,         &
+ SUBROUTINE find_vertical_neighbours_and_weights_interp( palm_grid,         &
                                                             palm_intermediate )
-       TYPE(grid_definition), INTENT(INOUT) ::  palm_grid
-       TYPE(grid_definition), INTENT(IN)    ::  palm_intermediate
-
-       INTEGER  ::  i, j, k, nx, ny, nz, nlev, k_intermediate
-       LOGICAL  ::  point_is_below_grid, point_is_above_grid,                  &
-                    point_is_in_current_cell
-       REAL(dp) ::  current_height, column_base, column_top, h_top, h_bottom,  &
-                    weight
-
-       nx   = palm_grid % nx
-       ny   = palm_grid % ny
-       nz   = palm_grid % nz
-       nlev = palm_intermediate % nz
-
-!
-!--    in each column of the fine grid, find vertical neighbours of every cell
-       DO j = 0, ny
-       DO i = 0, nx
-
-          k_intermediate = 0
-
-          column_base = palm_intermediate % h(i,j,0)
-          column_top  = palm_intermediate % h(i,j,nlev)
-
-!
-!--       scan through palm_grid column and set neighbour indices in
-!--       case current_height is either below column_base, in the current
-!--       cell, or above column_top. Keep increasing current cell index until
-!--       the current cell overlaps with the current_height.
-          DO k = 1, nz
-
-!
-!--          Memorize the top and bottom boundaries of the coarse cell and the
-!--          current height within it
-             current_height = palm_grid % z(k) + palm_grid % z0
-             h_top    = palm_intermediate % h(i,j,k_intermediate+1)
-             h_bottom = palm_intermediate % h(i,j,k_intermediate)
-
-             point_is_above_grid = (current_height > column_top) !22000m, very unlikely
-             point_is_below_grid = (current_height < column_base)
-
-             point_is_in_current_cell = (                                      &
-                current_height >= h_bottom .AND.                               &
-                current_height <  h_top                                        &
-             )
-
-!
-!--          set default weights
-             palm_grid % w_verti(i,j,k,1:2) = 0.0_dp
-
-             IF (point_is_above_grid)  THEN
-
-                palm_grid % kk(i,j,k,1:2) = nlev
-                palm_grid % w_verti(i,j,k,1:2) = - 2.0_dp
-
-                message = "PALM-4U grid extends above COSMO-DE model top."
-                CALL inifor_abort('find_vertical_neighbours_and_weights', message)
-
-             ELSE IF (point_is_below_grid)  THEN
-
-                palm_grid % kk(i,j,k,1:2) = 0
-                palm_grid % w_verti(i,j,k,1:2) = - 2.0_dp
-
-             ELSE
-!
-!--             cycle through intermediate levels until current
-!--             intermediate-grid cell overlaps with current_height
-                DO WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
-                   k_intermediate = k_intermediate + 1
-
-                   h_top    = palm_intermediate % h(i,j,k_intermediate+1)
-                   h_bottom = palm_intermediate % h(i,j,k_intermediate)
-                   point_is_in_current_cell = (                                &
-                      current_height >= h_bottom .AND.                         &
-                      current_height <  h_top                                  &
-                   )
-                ENDDO
-
-                IF (k_intermediate > nlev-1)  THEN
-                   message = "Index " // TRIM(str(k_intermediate)) //          &
-                             " is above intermediate grid range."
-                   CALL inifor_abort('find_vertical_neighbours', message)
-                ENDIF
+    TYPE(grid_definition), INTENT(INOUT) ::  palm_grid
+    TYPE(grid_definition), INTENT(IN)    ::  palm_intermediate
+
+    INTEGER  ::  i, j, k, nx, ny, nz, nlev, k_intermediate
+    LOGICAL  ::  point_is_below_grid, point_is_above_grid,                  &
+                 point_is_in_current_cell
+    REAL(wp) ::  current_height, column_base, column_top, h_top, h_bottom,  &
+                 weight
+
+    nx   = palm_grid%nx
+    ny   = palm_grid%ny
+    nz   = palm_grid%nz
+    nlev = palm_intermediate%nz
+
+!
+!-- in each column of the fine grid, find vertical neighbours of every cell
+    DO  j = 0, ny
+    DO  i = 0, nx
+
+       k_intermediate = 0
+
+       column_base = palm_intermediate%h(i,j,0)
+       column_top  = palm_intermediate%h(i,j,nlev)
+
+!
+!--    scan through palm_grid column and set neighbour indices in
+!--    case current_height is either below column_base, in the current
+!--    cell, or above column_top. Keep increasing current cell index until
+!--    the current cell overlaps with the current_height.
+       DO  k = 1, nz
+
+!
+!--       Memorize the top and bottom boundaries of the coarse cell and the
+!--       current height within it
+          current_height = palm_grid%z(k) + palm_grid%z0
+          h_top    = palm_intermediate%h(i,j,k_intermediate+1)
+          h_bottom = palm_intermediate%h(i,j,k_intermediate)
+
+          point_is_above_grid = (current_height > column_top) !22000m, very unlikely
+          point_is_below_grid = (current_height < column_base)
+
+          point_is_in_current_cell = (                                      &
+             current_height >= h_bottom .AND.                               &
+             current_height <  h_top                                        &
+          )
+
+!
+!--       set default weights
+          palm_grid%w_verti(i,j,k,1:2) = 0.0_wp
+
+          IF (point_is_above_grid)  THEN
+
+             palm_grid%kk(i,j,k,1:2) = nlev
+             palm_grid%w_verti(i,j,k,1:2) = - 2.0_wp
+
+             message = "PALM-4U grid extends above COSMO-DE model top."
+             CALL inifor_abort('find_vertical_neighbours_and_weights', message)
+
+          ELSE IF (point_is_below_grid)  THEN
+
+             palm_grid%kk(i,j,k,1:2) = 0
+             palm_grid%w_verti(i,j,k,1:2) = - 2.0_wp
+
+          ELSE
+!
+!--          cycle through intermediate levels until current
+!--          intermediate-grid cell overlaps with current_height
+             DO  WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
+                k_intermediate = k_intermediate + 1
+
+                h_top    = palm_intermediate%h(i,j,k_intermediate+1)
+                h_bottom = palm_intermediate%h(i,j,k_intermediate)
+                point_is_in_current_cell = (                                &
+                   current_height >= h_bottom .AND.                         &
+                   current_height <  h_top                                  &
+                )
+             ENDDO
+
+             IF (k_intermediate > nlev-1)  THEN
+                message = "Index " // TRIM(str(k_intermediate)) //          &
+                          " is above intermediate grid range."
+                CALL inifor_abort('find_vertical_neighbours', message)
+             ENDIF
    
-                palm_grid % kk(i,j,k,1) = k_intermediate
-                palm_grid % kk(i,j,k,2) = k_intermediate + 1
-
-!
-!--             compute vertical weights
-                weight = (h_top - current_height) / (h_top - h_bottom)
-                palm_grid % w_verti(i,j,k,1) = weight
-                palm_grid % w_verti(i,j,k,2) = 1.0_dp - weight
-             ENDIF
-
-          ENDDO
+             palm_grid%kk(i,j,k,1) = k_intermediate
+             palm_grid%kk(i,j,k,2) = k_intermediate + 1
+
+!
+!--          compute vertical weights
+             weight = (h_top - current_height) / (h_top - h_bottom)
+             palm_grid%w_verti(i,j,k,1) = weight
+             palm_grid%w_verti(i,j,k,2) = 1.0_wp - weight
+          ENDIF
 
        ENDDO
-       ENDDO
-
-    END SUBROUTINE find_vertical_neighbours_and_weights_interp
+
+    ENDDO
+    ENDDO
+
+ END SUBROUTINE find_vertical_neighbours_and_weights_interp
 
 
